commit fae7704ff6c3d375161166ffde137a0a8477507b
Author: freddy77 <freddy77>
Date:   Sun Dec 13 10:37:37 2009 +0000

    Fix posting longbinary on Sybase server

diff --git a/ChangeLog b/ChangeLog
index 2dd1e37..c102b13 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sun Dec 13 11:37:31 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/ctlib/unittests/rpc_ct_setparam.c src/tds/query.c:
+	- Fix posting longbinary on Sybase server
+
 Sun Dec 13 11:36:48 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/unittests/t0006.c: Style and comments
 
@@ -1970,4 +1974,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2902 2009/12/13 10:36:54 freddy77 Exp $
+$Id: ChangeLog,v 1.2903 2009/12/13 10:37:37 freddy77 Exp $
diff --git a/src/ctlib/unittests/rpc_ct_setparam.c b/src/ctlib/unittests/rpc_ct_setparam.c
index b081b02..3d8f2d4 100644
--- a/src/ctlib/unittests/rpc_ct_setparam.c
+++ b/src/ctlib/unittests/rpc_ct_setparam.c
@@ -18,7 +18,7 @@
 #define MAX(X,Y)      (((X) > (Y)) ? (X) : (Y))
 #define MIN(X,Y)      (((X) < (Y)) ? (X) : (Y))
 
-static char software_version[] = "$Id: rpc_ct_setparam.c,v 1.9 2006/12/29 19:00:33 freddy77 Exp $";
+static char software_version[] = "$Id: rpc_ct_setparam.c,v 1.10 2009/12/13 10:37:37 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 CS_RETCODE ex_clientmsg_cb(CS_CONTEXT * context, CS_CONNECTION * connection, CS_CLIENTMSG * errmsg);
@@ -87,7 +87,7 @@ main(int argc, char *argv[])
         @sintparam smallint output, @floatparam float output, \
         @moneyparam money output,  \
         @dateparam datetime output, @charparam char(20) output, \
-        @binaryparam    binary(20) output) \
+        @binaryparam    varbinary(2000) output) \
         as ");
 
 	strcat(cmdbuf, "select @intparam, @sintparam, @floatparam, @moneyparam, \
@@ -266,8 +266,8 @@ main(int argc, char *argv[])
 
 	strcpy(datafmt.name, "@binaryparam");
 	datafmt.namelen = CS_NULLTERM;
-	datafmt.datatype = CS_BINARY_TYPE;
-	datafmt.maxlength = 255;
+	datafmt.datatype = CS_LONGBINARY_TYPE;
+	datafmt.maxlength = 2000;
 	datafmt.status = CS_RETURN;
 	datafmt.locale = NULL;
 
diff --git a/src/tds/query.c b/src/tds/query.c
index 7200afb..4dd1d18 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.242 2009/10/02 09:24:08 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.243 2009/12/13 10:37:37 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -1390,6 +1390,7 @@ tds_put_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 		case 2:
 			tds_put_smallint(tds, size);
 			break;
+		case 5:
 		case 4:
 			tds_put_int(tds, size);
 			break;
@@ -1437,6 +1438,8 @@ tds_put_data_info_length(TDSSOCKET * tds, TDSCOLUMN * curcol, int flags)
 		len += curcol->column_namelen;
 	if (is_numeric_type(curcol->on_server.column_type))
 		len += 2;
+	if (curcol->column_varint_size == 5)
+		return len + 4;
 	return len + curcol->column_varint_size;
 }
 
@@ -1464,6 +1467,9 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	if (curcol->column_cur_size < 0) {
 		tdsdump_log(TDS_DBG_INFO1, "tds_put_data: null param\n");
 		switch (curcol->column_varint_size) {
+		case 5:
+			tds_put_int(tds, 0);
+			break;
 		case 4:
 			tds_put_int(tds, -1);
 			break;
@@ -1588,6 +1594,10 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		/* TODO ICONV handle charset conversions for data */
 		/* put size of data */
 		switch (curcol->column_varint_size) {
+		case 5:	/* It's a LONGBINARY */
+			colsize = MIN(colsize, 0x7fffffff);
+			tds_put_int(tds, colsize);
+			break;
 		case 4:	/* It's a BLOB... */
 			tds_put_byte(tds, 16);
 			tds_put_n(tds, blob->textptr, 16);

